/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM /builddir/build/BUILD/thunderbird-3.0/mailnews/compose/public/nsIMsgSendLater.idl
 */

#ifndef __gen_nsIMsgSendLater_h__
#define __gen_nsIMsgSendLater_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIStreamListener_h__
#include "nsIStreamListener.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIMsgStatusFeedback; /* forward declaration */

class nsIMsgIdentity; /* forward declaration */

class nsIMsgSendLaterListener; /* forward declaration */

class nsIMsgFolder; /* forward declaration */


/* starting interface:    nsIMsgSendLater */
#define NS_IMSGSENDLATER_IID_STR "2e2142b2-8f94-4604-8cc7-06a00d59f6b5"

#define NS_IMSGSENDLATER_IID \
  {0x2e2142b2, 0x8f94, 0x4604, \
    { 0x8c, 0xc7, 0x06, 0xa0, 0x0d, 0x59, 0xf6, 0xb5 }}

/**
 * nsIMsgSendLater is a service used for sending messages in the background.
 * Messages should be saved to an identity's unsent messages folder, and then
 * can be sent by calling sendUnsentMessages.
 */
class NS_NO_VTABLE NS_SCRIPTABLE nsIMsgSendLater : public nsIStreamListener {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IMSGSENDLATER_IID)

  /* attribute nsIMsgStatusFeedback statusFeedback; */
  NS_SCRIPTABLE NS_IMETHOD GetStatusFeedback(nsIMsgStatusFeedback * *aStatusFeedback) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetStatusFeedback(nsIMsgStatusFeedback * aStatusFeedback) = 0;

  /**
   * Sends any unsent messages in the identity's unsent messages folder.
   *
   * @param aIdentity   The identity to send messages for.
   */
  /* void sendUnsentMessages (in nsIMsgIdentity aIdentity); */
  NS_SCRIPTABLE NS_IMETHOD SendUnsentMessages(nsIMsgIdentity *aIdentity) = 0;

  /**
   * Adds an listener to the service to receive notifications.
   *
   * @param aListener   The listener to add.
   */
  /* void addListener (in nsIMsgSendLaterListener aListener); */
  NS_SCRIPTABLE NS_IMETHOD AddListener(nsIMsgSendLaterListener *aListener) = 0;

  /**
   * Removes a listener from the service.
   *
   * @param aListener                 The listener to remove.
   * @exception NS_ERROR_INVALID_ARG  If the listener was not already added to
   *                                  the service.
   */
  /* void removeListener (in nsIMsgSendLaterListener aListener); */
  NS_SCRIPTABLE NS_IMETHOD RemoveListener(nsIMsgSendLaterListener *aListener) = 0;

  /**
   * Returns the unsent messages folder for the identity.
   */
  /* nsIMsgFolder getUnsentMessagesFolder (in nsIMsgIdentity userIdentity); */
  NS_SCRIPTABLE NS_IMETHOD GetUnsentMessagesFolder(nsIMsgIdentity *userIdentity, nsIMsgFolder **_retval NS_OUTPARAM) = 0;

  /* readonly attribute boolean sendingMessages; */
  NS_SCRIPTABLE NS_IMETHOD GetSendingMessages(PRBool *aSendingMessages) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIMsgSendLater, NS_IMSGSENDLATER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIMSGSENDLATER \
  NS_SCRIPTABLE NS_IMETHOD GetStatusFeedback(nsIMsgStatusFeedback * *aStatusFeedback); \
  NS_SCRIPTABLE NS_IMETHOD SetStatusFeedback(nsIMsgStatusFeedback * aStatusFeedback); \
  NS_SCRIPTABLE NS_IMETHOD SendUnsentMessages(nsIMsgIdentity *aIdentity); \
  NS_SCRIPTABLE NS_IMETHOD AddListener(nsIMsgSendLaterListener *aListener); \
  NS_SCRIPTABLE NS_IMETHOD RemoveListener(nsIMsgSendLaterListener *aListener); \
  NS_SCRIPTABLE NS_IMETHOD GetUnsentMessagesFolder(nsIMsgIdentity *userIdentity, nsIMsgFolder **_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD GetSendingMessages(PRBool *aSendingMessages); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIMSGSENDLATER(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetStatusFeedback(nsIMsgStatusFeedback * *aStatusFeedback) { return _to GetStatusFeedback(aStatusFeedback); } \
  NS_SCRIPTABLE NS_IMETHOD SetStatusFeedback(nsIMsgStatusFeedback * aStatusFeedback) { return _to SetStatusFeedback(aStatusFeedback); } \
  NS_SCRIPTABLE NS_IMETHOD SendUnsentMessages(nsIMsgIdentity *aIdentity) { return _to SendUnsentMessages(aIdentity); } \
  NS_SCRIPTABLE NS_IMETHOD AddListener(nsIMsgSendLaterListener *aListener) { return _to AddListener(aListener); } \
  NS_SCRIPTABLE NS_IMETHOD RemoveListener(nsIMsgSendLaterListener *aListener) { return _to RemoveListener(aListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetUnsentMessagesFolder(nsIMsgIdentity *userIdentity, nsIMsgFolder **_retval NS_OUTPARAM) { return _to GetUnsentMessagesFolder(userIdentity, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetSendingMessages(PRBool *aSendingMessages) { return _to GetSendingMessages(aSendingMessages); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIMSGSENDLATER(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetStatusFeedback(nsIMsgStatusFeedback * *aStatusFeedback) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStatusFeedback(aStatusFeedback); } \
  NS_SCRIPTABLE NS_IMETHOD SetStatusFeedback(nsIMsgStatusFeedback * aStatusFeedback) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetStatusFeedback(aStatusFeedback); } \
  NS_SCRIPTABLE NS_IMETHOD SendUnsentMessages(nsIMsgIdentity *aIdentity) { return !_to ? NS_ERROR_NULL_POINTER : _to->SendUnsentMessages(aIdentity); } \
  NS_SCRIPTABLE NS_IMETHOD AddListener(nsIMsgSendLaterListener *aListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddListener(aListener); } \
  NS_SCRIPTABLE NS_IMETHOD RemoveListener(nsIMsgSendLaterListener *aListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveListener(aListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetUnsentMessagesFolder(nsIMsgIdentity *userIdentity, nsIMsgFolder **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetUnsentMessagesFolder(userIdentity, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetSendingMessages(PRBool *aSendingMessages) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSendingMessages(aSendingMessages); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsMsgSendLater : public nsIMsgSendLater
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIMSGSENDLATER

  nsMsgSendLater();

private:
  ~nsMsgSendLater();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsMsgSendLater, nsIMsgSendLater)

nsMsgSendLater::nsMsgSendLater()
{
  /* member initializers and constructor code */
}

nsMsgSendLater::~nsMsgSendLater()
{
  /* destructor code */
}

/* attribute nsIMsgStatusFeedback statusFeedback; */
NS_IMETHODIMP nsMsgSendLater::GetStatusFeedback(nsIMsgStatusFeedback * *aStatusFeedback)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsMsgSendLater::SetStatusFeedback(nsIMsgStatusFeedback * aStatusFeedback)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void sendUnsentMessages (in nsIMsgIdentity aIdentity); */
NS_IMETHODIMP nsMsgSendLater::SendUnsentMessages(nsIMsgIdentity *aIdentity)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addListener (in nsIMsgSendLaterListener aListener); */
NS_IMETHODIMP nsMsgSendLater::AddListener(nsIMsgSendLaterListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeListener (in nsIMsgSendLaterListener aListener); */
NS_IMETHODIMP nsMsgSendLater::RemoveListener(nsIMsgSendLaterListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIMsgFolder getUnsentMessagesFolder (in nsIMsgIdentity userIdentity); */
NS_IMETHODIMP nsMsgSendLater::GetUnsentMessagesFolder(nsIMsgIdentity *userIdentity, nsIMsgFolder **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean sendingMessages; */
NS_IMETHODIMP nsMsgSendLater::GetSendingMessages(PRBool *aSendingMessages)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIMsgSendLater_h__ */
